* NVDI_FIX.S by Gair Shields. gshields@CIX (DevpacST2 format)

* Fixes a bug in NVDI, which crashes the machine if a program calles
* v_opnvwk() in NDC mode.

* This bug is present running under TOS 1.02 and I have never checked for it
* on any other machine. The NDC_DEMO program supplied with NVDI 2.50 will not
* work on my MEGA ST4 without first running this patch.

* You should only modify:-  NVDI.PRG, V2.50, 40792 bytes.
* This code makes no checks and reports no errors, so make a backup first.
* YOU HAVE BEEN WARNED!!!


	lea	stack(pc),a7		
	move.w	#2,-(sp)
	pea	filename(pc)
	move.w	#$3d,-(sp)
	trap	#1			open file
	addq.l	#8,sp
	move.l	d0,d3
	bmi.s	quit			error
	moveq	#2,d4			three patches to perform
	lea	seek_data(pc),a3
seek	clr.w	-(sp)
	move.w	d3,-(sp)
	move.l	(a3)+,-(sp)
	move.w	#$42,-(sp)
	trap	#1			fseek 
	lea	10(sp),sp
	move.l	(a3)+,-(sp)
	move.l	(a3)+,-(sp)
	move.w	d3,-(sp)
	move.w	#$40,-(sp)
	trap	#1			patch it up
	lea	12(sp),sp
	dbf	d4,seek
	move.w	d3,-(sp)
	move.w	#$3e,-(sp)
	trap	#1			close file
	addq.l	#4,sp
quit	clr.w	-(sp)
	move.w	#$4c,-(sp)
	trap	#1			and goodbye..
	illegal
	
	data

patch_pos =	$9668	offset to patch code in file NVDI.PRG

seek_data
	dc.l	$32a0,bra_fix,2
	dc.l	patch_pos,patchcode,16
	dc.l	$9625,version,20
bra_fix	
	dc.w	patch_pos-$329e			
patchcode
	dc.l	$48e7,$c0006100,$8f404cdf,$34e75
version
	dc.b	"NVDI V2.50 (Patched)"
filename
	dc.b	"nvdi.prg",0

	bss	
	ds.l	50
stack	ds.l	1